"""
Define some generators based on the caching mechanism that
are commonly needed for code generation
"""

from dune.perftool.generation import generator_factory
from dune.perftool.cgen.clazz import AccessModifier 

symbol = generator_factory(item_tags=("symbol",))


def include_file(include, filetag="operator"):
    from cgen import Include
    gen = generator_factory(on_store=lambda i: Include(i), item_tags=(filetag, "include"), no_deco=True)
    return gen(include)


# TODO this should perhaps already take into account a potential construction of the base class object
def base_class(baseclass, classtag=None, access=AccessModifier.PUBLIC):
    assert classtag
    from dune.perftool.cgen.clazz import BaseClass
    gen = generator_factory(item_tags=("baseclass", classtag), on_store=lambda n: BaseClass(n, inheritance=access), counted=True, no_deco=True)
    return gen(baseclass)


def preamble(tag):
    return generator_factory(item_tags=(tag, "preamble"), counted=True)